
#include <Wire.h>
#include <Servo.h> 

const int MPU = 0x68; // MPU6050 I2C address
float AccX, AccY, AccZ;
float GyroX, GyroY, GyroZ;
float accAngleX, accAngleY, gyroAngleX, gyroAngleY, gyroAngleZ;
float roll, pitch, yaw;
float errorZ[200];
float GyroErrorZ = 0, zError = 0, zMiddle = 0;
float elapsedTime, currentTime, previousTime;
int c = 0, i = 0;
int servoPin = 9;
int servoAngle;
int servoZero = 102;

bool flag;

Servo servo1;

void setup() {
  // put your setup code here, to run once:
 servo1.attach(servoPin);
  servoAngle = servoZero;
  servo1.write(servoAngle);

  flag = true;
  
  Serial.begin(19200);
  Wire.begin();                      // Initialize comunication
  Wire.beginTransmission(MPU);       // Start communication with MPU6050 // MPU=0x68
  Wire.write(0x6B);                  // Talk to the register 6B
  Wire.write(0x00);                  // Make reset - place a 0 into the 6B register
  Wire.endTransmission(true);        //end the 

}

void loop() {
  // put your main code here, to run repeatedly:

  previousTime = currentTime;        // Previous time is stored before the actual time read
  currentTime = millis();            // Current time actual time read
  elapsedTime = (currentTime - previousTime) / 1000; 

  Wire.beginTransmission(MPU);
  Wire.write(0x43); // Gyro data first register address 0x43
  Wire.endTransmission(false);
  Wire.requestFrom(MPU, 6, true); // Read 4 registers total, each axis value is stored in 2 registers
  GyroX = (Wire.read() << 8 | Wire.read()) / 131.0; // For a 250deg/s range we have to divide first the raw value by 131.0, according to the datasheet
  GyroY = (Wire.read() << 8 | Wire.read()) / 131.0;
  GyroZ = (Wire.read() << 8 | Wire.read()) / 131.0;
  // Correct the outputs with the calculated error values
    //GyroZ = GyroZ + zError; // GyroErrorZ ~ (0.72)
  if(c < 200){
    errorZ[c] = GyroZ;
    GyroErrorZ = GyroErrorZ + GyroZ;
    delay(10);
    c++;
  }
  else{
    if(flag){
      while(i<200){
        if(abs(zError) < abs(errorZ[i])){
          zError = errorZ[i];
        }
        i++;
      }
      zMiddle = GyroErrorZ/200;
     // servo1.write(servoAngle + 10);
      delay(1000);
     // servo1.write(servoAngle - 10);
      flag = false;
      }
    GyroZ = GyroZ - zMiddle;
    yaw =  yaw + GyroZ * elapsedTime;
          
      servo1.write(servoAngle+ yaw);   
       
    Serial.println(((String)yaw) + " - " + (String)GyroZ + " | "+ (String)zError + "|" + (String)zMiddle);
   // delay(10);
  }
}

